from __future__ import annotations

from typing import Any

from components.base_component import BaseComponent

class Fighter(BaseComponent):
	entity: Any

	def __init__(self, hp: int, attack: int, defense: int):
		self._maximum_hp = hp
		self._current_hp = hp
		self.attack = attack
		self.defense = defense

	@property
	def current_hp(self) -> int:
		return self._current_hp

	@current_hp.setter
	def current_hp(self, value: int) -> None:
		self._current_hp = max(0, min(value, self._maximum_hp))

